package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallSeckillSessionApplicationService;
import com.jeesharp.business.modules.mall.dto.MallSeckillSessionSaveDTO;
import com.jeesharp.business.modules.mall.vo.MallSeckillSessionInfoVO;
import com.jeesharp.business.modules.mall.vo.MallSeckillSessionListVO;
import com.jeesharp.business.modules.mall.vo.MallSeckillSessionQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;

/**
 * 秒杀场次管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/seckill/session/v1")
@Tag(name = "秒杀场次管理")
@AllArgsConstructor
public class MallSeckillSessionController extends BaseController {

    private final MallSeckillSessionApplicationService mallSeckillSessionApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallSeckillSessionInfoVO> info(@RequestParam("id") String id) {
        MallSeckillSessionInfoVO vo = mallSeckillSessionApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallSeckillSessionListVO>> list(@RequestBody MallSeckillSessionQueryVO query) {
        PageRespVO<MallSeckillSessionListVO> page = mallSeckillSessionApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallSeckillSessionSaveDTO dto) {
        mallSeckillSessionApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallSeckillSessionApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }
}
